# LayoutPointers

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaSIMD.github.io/LayoutPointers.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaSIMD.github.io/LayoutPointers.jl/dev)
[![Build Status](https://github.com/JuliaSIMD/LayoutPointers.jl/workflows/CI/badge.svg)](https://github.com/JuliaSIMD/LayoutPointers.jl/actions)
[![Coverage](https://codecov.io/gh/JuliaSIMD/LayoutPointers.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaSIMD/LayoutPointers.jl)

function _precompile_()
  ccall(:jl_generating_output, Cint, ()) == 1 || return nothing
  for T in (Bool, Int, Float32, Float64)
    for A in (Vector, Matrix)
      precompile(stridedpointer, (A{T},))
      precompile(stridedpointer, (LinearAlgebra.Adjoint{T,A{T}},))
    end
  end
end

module LayoutPointers
if isdefined(Base, :Experimental) && isdefined(Base.Experimental, Symbol("@max_methods"))
  @eval Base.Experimental.@max_methods 1
end

using Static, LinearAlgebra, StaticArrayInterface
using SIMDTypes: Bit, FloatingTypes, IntegerTypesHW
using Static: Zero, One
using StaticArrayInterface:
  contiguous_axis,
  contiguous_axis_indicator,
  contiguous_batch_size,
  stride_rank,
  offsets,
  offset1,
  CPUTuple,
  static_first,
  static_step,
  static_strides,
  CPUPointer,
  StrideIndex,
  offsets
using ManualMemory: preserve_buffer, offsetsize

export stridedpointer

const IntegerTypes = Union{IntegerTypesHW,StaticInt}

@inline _map(f::F, x::Tuple{}) where {F} = ()
@inline _map(f::F, x::Tuple{X1}) where {F,X1} = (f(getfield(x, 1, false)),)
@inline _map(f::F, x::Tuple{X1,X2,Vararg{Any,K}}) where {F,X1,X2,K} =
  (f(getfield(x, 1, false)), _map(f, Base.tail(x))...)

@inline _map(f::F, x::Tuple{}, y::Tuple{}) where {F} = ()
@inline _map(f::F, x::Tuple{X1}, y::Tuple{Y1}) where {F,X1,Y1} =
  (f(getfield(x, 1, false), getfield(y, 1, false)),)
@inline _map(
  f::F,
  x::Tuple{X1,X2,Vararg{Any,K}},
  y::Tuple{Y1,Y2,Vararg{Any,K}},
) where {F,X1,X2,Y1,Y2,K} =
  (f(getfield(x, 1, false), getfield(y, 1, false)), _map(f, Base.tail(x), Base.tail(y))...)


"""
  abstract type AbstractStridedPointer{T,N,C,B,R,X<:Tuple{Vararg{Union{Int,StaticInt},N}},O<:Tuple{Vararg{Union{Int,StaticInt},N}}} end

T: element type
N: dimensionality
C: contiguous dim
B: batch size
R: rank of strides
X: strides
O: offsets
"""
abstract type AbstractStridedPointer{
  T,
  N,
  C,
  B,
  R,
  X<:Tuple{Vararg{IntegerTypes,N}},
  O<:Tuple{Vararg{IntegerTypes,N}},
} end


include("stridedpointers.jl")
include("grouped_strided_pointers.jl")
include("precompile.jl")

end

"""
P are the pointers
I contains indexes into `strides` (dynamic) and `X` (static)
X static strides
"""
struct GroupedStridedPointers{P,C,B,R,I,X,O}
  ptrs::P
  strides::X
  offsets::O
end

@inline function GroupedStridedPointers{P,C,B,R,I}(
  ptrs::P,
  strides::X,
  offsets::O,
) where {P,C,B,R,I,X,O}
  GroupedStridedPointers{P,C,B,R,I,X,O}(ptrs, strides, offsets)
end

@inline function map_mem_ref(A::Tuple{P}) where {P}
  p, r = memory_reference(first(A))
  (p,), (r,)
end
@inline function map_mem_ref(A::Tuple{P,T,Vararg}) where {P,T}
  p, r = memory_reference(first(A))
  pt, rt = map_mem_ref(Base.tail(A))
  (p, pt...), (r, rt...)
end

struct DensePointerWrapper{D,T,N,C,B,R,X,O,P<:AbstractStridedPointer{T,N,C,B,R,X,O}} <:
       AbstractStridedPointer{T,N,C,B,R,X,O}
  p::P
end

@inline val_dense_dims(::DensePointerWrapper{D}) where {D} = Val{D}()

@inline Base.pointer(A::DensePointerWrapper) = pointer(getfield(A, :p))
@inline StaticArrayInterface.StrideIndex(sptr::DensePointerWrapper) =
  StrideIndex(getfield(sptr, :p))


@inline DensePointerWrapper{D}(
  sp::P,
) where {D,T,N,C,B,R,X,O,P<:AbstractStridedPointer{T,N,C,B,R,X,O}} =
  DensePointerWrapper{D,T,N,C,B,R,X,O,P}(sp)

@inline _gp_strides(x::StrideIndex) = getfield(x, :strides)
@inline _gp_strides(x) = static_strides(x)
@inline _gp_strides(::NoStrides) = NoStrides()
grouped_strided_pointer(::Tuple{}, ::Val{()}) = ((), ())

"""
G is a tuple(tuple((A_ind,A's dim),(A_ind,A's dim)), ())
it gives the groups.
"""
@inline function grouped_strided_pointer(
  A::Tuple{Vararg{Union{AbstractArray,AbstractStridedPointer,FastRange},N}},
  ::Val{G},
) where {N,G}
  m, r = map_mem_ref(A)
  sis = _map(bytestrideindex, A)
  grouped_strided_pointer(
    m,
    _map(contiguous_axis, A),
    _map(contiguous_batch_size, A),
    _map(val_stride_rank, A),
    _map(_gp_strides, sis),
    _map(offsets, sis),
    _map(val_dense_dims, A),
    Val{G}(),
  ),
  r
end

@generated function grouped_strided_pointer(
  ptrs::P,
  contig_axis::C,
  batch_sz::B,
  r::R,
  x::X,
  o::O,
  d::D,
  ::Val{()},
) where {P,C,B,R,X,O,D}
  # no groups
  N = length(P.parameters)
  q = Expr(:block, Expr(:meta, :inline))
  i = 0
  Ct = Expr(:tuple)
  Bt = Expr(:tuple)
  Rt = Expr(:tuple)
  Xt = Expr(:tuple)
  Ot = Expr(:tuple)
  It = Expr(:tuple)
  for n = 1:N
    push!(Ct.args, C.parameters[n].parameters[1])
    push!(Bt.args, B.parameters[n].parameters[1])
    push!(Rt.args, R.parameters[n].parameters[1])
    Xₙ = X.parameters[n]# Oₙ = O.parameters[n];
    Itt = Expr(:tuple)
    if !iszero(length(Xₙ.parameters))
      xₙ = Symbol(:x_, n)
      oₙ = Symbol(:o_, n)
      push!(q.args, Expr(:(=), xₙ, Expr(:call, Core.getfield, :x, n, false)))
      push!(q.args, Expr(:(=), oₙ, Expr(:call, Core.getfield, :o, n, false)))
      for j ∈ 1:length(Xₙ.parameters)
        push!(Xt.args, Expr(:call, Core.getfield, xₙ, j, false))
        push!(Ot.args, Expr(:call, Core.getfield, oₙ, j, false))
        push!(Itt.args, (i += 1))
      end
    end
    push!(It.args, Itt)
  end
  push!(q.args, :(GroupedStridedPointers{$P,$Ct,$Bt,$Rt,$It}(ptrs, $Xt, $Ot)))
  q
end

function ordered_rank_and_sort(R::NTuple{N,Int}) where {N}
  sp = ntuple(zero, Val{N}())
  r = ntuple(n -> sum(R[n] .≥ R), Val{N}())
  @inbounds for n = 1:N
    sp = Base.setindex(sp, n, r[n])
  end
  (r, sp)::NTuple{2,NTuple{N,Int}}
end

function matching_values(Xₙ, j, Xₚ, k)::Bool
  xₙⱼ = Xₙ[j]
  xₙⱼ === Int && return false
  xₚₖ = Xₚ[k]
  xₚₖ === Int && return false
  xₙⱼ === xₚₖ
end

function check_match(pm, Rₙ, Sₙ, Xₙ, Dₙ, j, Rₚ, Sₚ, Xₚ, Dₚ, k)::Bool
  # if strides match, we're done
  # @show Xₙ, j, Xₚ, k
  matching_values(Xₙ, j, Xₚ, k) && return true
  Rₙⱼ = Rₙ[j]
  Rₚₖ = Rₚ[k]
  if Rₚₖ > 1 && Rₙⱼ > 1
    # Otherwise, we check preceding axis
    nind = Sₙ[Rₙⱼ-1]
    pind = Sₚ[Rₚₖ-1]
    # matching_values(Xₙ, nind, Xₚ, pind) && return true
    # for them being of equal size,
    # @show pm[nind, pind], Dₙ[j], Dₚ[k], nind, pind
    if pm[nind, pind] && Dₙ[j] && Dₚ[k]
      return check_match(pm, Rₙ, Sₙ, Xₙ, Dₙ, nind, Rₚ, Sₚ, Xₚ, Dₚ, pind)
    end
  end
  false
end
# _typesize(@nospecialize(_::Type{Ptr{T}})) where {T} = (Base.allocatedinline(T) ? sizeof(T) : sizeof(Int))::Int
# _typesize(@nospecialize(_)) = -1
@generated function grouped_strided_pointer(
  ptrs::P,
  contig_axis::C,
  batch_sz::B,
  r::R,
  x::X,
  o::O,
  d::D,
  ::Val{G},
) where {P,C,B,R,X,O,D,G}
  # 1+1
  N = length(P.parameters)
  # We search for stride matches here
  # first we go over the groups, looking for matches
  m = Matrix{Matrix{Bool}}(undef, N, N)
  for g ∈ G
    # each `g` is a tuple of (array ind, paired dim)
    ng = length(g)
    for i ∈ 1:ng
      ai, di = g[i]
      # @show ai, di
      idim = length(X.parameters[ai].parameters)
      for j ∈ i+1:ng
        aj, dj = g[j]
        # @show aj, dj
        jdim = length(X.parameters[aj].parameters)
        pm = if isassigned(m, LinearIndices(m)[ai, aj])
          m[ai, aj]
        elseif ai < aj
          m[ai, aj] = m[aj, ai] = fill(false, jdim, idim)
          # m[aj,ai] = fill(false, idim, jdim)
        elseif ai > aj
          m[ai, aj] = m[aj, ai] = fill(false, idim, jdim)
          # m[ai,aj] = fill(false, jdim, idim)
        end
        if ai < aj
          if checkbounds(Bool, pm, dj, di)
            @inbounds pm[dj, di] = true
          end
        elseif ai > aj
          if checkbounds(Bool, pm, di, dj)
            @inbounds pm[di, dj] = true
          end
        end
      end
    end
  end
  # eltypesizes = Vector{Int}(undef, N)
  # for n in 1:N
  #   eltypesizes[n] = _typesize(P.parameters[n])
  # end
  # @show m G
  # Here we check for static size equivalence info
  # m contains information on matching sizes
  q = Expr(:block, Expr(:meta, :inline))
  i = 0
  staticxs = Bool[]
  staticos = Bool[]
  Ct = Expr(:tuple)
  Bt = Expr(:tuple)
  Rt = Expr(:tuple)
  Xt = Expr(:tuple)
  Ot = Expr(:tuple)
  It = Expr(:tuple)
  for n = 1:N
    push!(Ct.args, C.parameters[n].parameters[1])
    push!(Bt.args, B.parameters[n].parameters[1])
    Rₙ = R.parameters[n].parameters[1]
    push!(Rt.args, Rₙ)
    Xₙ = X.parameters[n].parameters
    Itt = Expr(:tuple)
    ndim = length(Xₙ)
    if ndim > 0
      Rₙ, Sₙ = ordered_rank_and_sort(Rₙ)
      Dₙ = D.parameters[n].parameters[1]
      xₙ = Symbol(:x_, n)
      oₙ = Symbol(:o_, n)
      xₙ_not_extracted = true
      oₙ_not_extracted = true
      for j = 1:ndim
        # Here, we now check if we actually need to add info, or if we can find it
        match = false
        Rₙⱼ = (Rₙ[j])::Int
        # nprev_max = isone(Rₙⱼ) ? 0 : n - 1
        for nprev = 1:n-1#ifelse(eltypesizes[n] == -1, 0, n - 1)
          # eltypematch = (eltypesizes[nprev] == eltypesizes[n])
          # @show n, nprev
          isassigned(m, LinearIndices(m)[n, nprev]) || continue
          pm = m[n, nprev] # just accessing lower triangle, but matrix is symmetric
          # pm is ndim_n x ndim_nprev
          # we need to search back through stride ranks...
          for k ∈ axes(pm, 2)
            Rₚ, Sₚ = ordered_rank_and_sort(R.parameters[nprev].parameters[1])
            Dₚ = D.parameters[nprev].parameters[1]
            Xₚ = X.parameters[nprev].parameters
            match |= check_match(pm, Rₙ, Sₙ, Xₙ, Dₙ, j, Rₚ, Sₚ, Xₚ, Dₚ, k)
            if match
              # must push nprev's ind
              storedindex = It.args[nprev].args[k]
              push!(Itt.args, storedindex)
              if (!staticxs[storedindex]) && (Xₙ[j] <: StaticInt)
                Xt.args[storedindex] = Expr(:call, Xₙ[j])
                staticxs[storedindex] = true
              end
              if (!staticos[storedindex]) && (O.parameters[n].parameters[j] <: StaticInt)
                Ot.args[storedindex] = Expr(:call, O.parameters[n].parameters[j])
                staticos[storedindex] = true
              end
              break
            end
          end
          match && break
        end
        if !match
          # @show Xₙ[j]
          xparam = Xₙ[j]
          xstatic = xparam <: StaticInt
          push!(staticxs, xstatic)
          if xstatic
            push!(Xt.args, Expr(:call, xparam))
          else
            if xₙ_not_extracted
              push!(q.args, Expr(:(=), xₙ, Expr(:call, Core.getfield, :x, n, false)))
              xₙ_not_extracted = false
            end
            push!(Xt.args, Expr(:call, Core.getfield, xₙ, j, false))
          end
          oparam = O.parameters[n].parameters[j]
          ostatic = oparam <: StaticInt
          push!(staticos, ostatic)
          if ostatic
            push!(Ot.args, Expr(:call, oparam))
          else
            if oₙ_not_extracted
              push!(q.args, Expr(:(=), oₙ, Expr(:call, Core.getfield, :o, n, false)))
              oₙ_not_extracted = false
            end
            push!(Ot.args, Expr(:call, Core.getfield, oₙ, j, false))
          end
          push!(Itt.args, (i += 1))
        end
      end
    end
    push!(It.args, Itt)
  end
  push!(q.args, :(GroupedStridedPointers{$P,$Ct,$Bt,$Rt,$It}(ptrs, $Xt, $Ot)))
  q
end

@generated function stridedpointers(
  gsp::GroupedStridedPointers{P,C,B,R,I,X,O},
) where {P,C,B,R,N,X<:Tuple{Vararg{Any,N}},O<:Tuple{Vararg{Any,N}},I}
  t = Expr(:tuple)
  gf = Core.getfield
  q = Expr(
    :block,
    Expr(:meta, :inline),
    :(ptrs = $gf(gsp, :ptrs)),
    :(strds = $gf(gsp, :strides)),
    :(offs = $gf(gsp, :offsets)),
  )
  for n ∈ 1:N
    push!(
      q.args,
      Expr(:(=), Symbol(:x_, n), Expr(:call, gf, :strds, n, false)),
      Expr(:(=), Symbol(:o_, n), Expr(:call, gf, :offs, n, false)),
    )
  end
  for i ∈ eachindex(I)
    p = Expr(:call, gf, :ptrs, i, false)
    if P.parameters[i] <: FastRange
      push!(t.args, p)
      continue
    end
    Iᵢ = I[i]
    Nᵢ = length(Iᵢ)
    x = Expr(:tuple)
    o = Expr(:tuple)
    for j ∈ Iᵢ
      push!(x.args, Symbol(:x_, j))
      push!(o.args, Symbol(:o_, j))
    end
    si = Expr(:call, Expr(:curly, :StrideIndex, Nᵢ, R[i], C[i]), x, o)
    push!(t.args, Expr(:call, :stridedpointer, p, si, :(StaticInt{$(B[i])}())))
  end
  push!(q.args, t)
  return q
end

using LayoutPointers, StaticArrayInterface, Aqua, Test
struct SizedWrapper{M,N,T,AT<:AbstractMatrix{T}} <: AbstractMatrix{T}
  A::AT
end
StaticArrayInterface.is_forwarding_wrapper(::Type{<:SizedWrapper}) = true
SizedWrapper{M,N}(A::AT) where {M,N,T,AT<:AbstractMatrix{T}} = SizedWrapper{M,N,T,AT}(A)
Base.size(::SizedWrapper{M,N}) where {M,N} = (M, N)
Base.getindex(A::SizedWrapper, i...) = getindex(parent(A), i...)
Base.parent(dw::SizedWrapper) = dw.A
StaticArrayInterface.parent_type(::Type{SizedWrapper{M,N,T,AT}}) where {M,N,T,AT} = AT
LayoutPointers.memory_reference(dw::SizedWrapper) =
  LayoutPointers.memory_reference(parent(dw))
StaticArrayInterface.contiguous_axis(dw::SizedWrapper) =
  LayoutPointers.contiguous_axis(parent(dw))
StaticArrayInterface.contiguous_batch_size(dw::SizedWrapper) =
  LayoutPointers.contiguous_batch_size(parent(dw))
LayoutPointers.val_stride_rank(dw::SizedWrapper) =
  LayoutPointers.val_stride_rank(parent(dw))
function StaticArrayInterface.static_strides(dw::SizedWrapper{M,N,T}) where {M,N,T}
  if LayoutPointers.val_stride_rank(dw) === Val((1, 2))
    return LayoutPointers.One(), LayoutPointers.StaticInt{M}()
  else#if LayoutPointers.val_stride_rank(dw) === Val((2,1))
    return LayoutPointers.StaticInt{N}(), LayoutPointers.One()
  end
end
StaticArrayInterface.offsets(dw::SizedWrapper) = LayoutPointers.offsets(parent(dw))
LayoutPointers.val_dense_dims(dw::SizedWrapper{T,N}) where {T,N} =
  LayoutPointers.val_dense_dims(parent(dw))

@testset "LayoutPointers.jl" begin
  Aqua.test_all(LayoutPointers)

  println("Grouped Strided Pointers")
  @time @testset "Grouped Strided Pointers" begin
    M, K, N = 4, 5, 6
    A = Matrix{Float64}(undef, M, K)
    B = Matrix{Float64}(undef, K, N)
    C = Matrix{Float64}(undef, M, N)

    GC.@preserve A B C begin
      fs = (false, true)#[identity, adjoint]
      for ai ∈ fs, bi ∈ fs, ci ∈ fs
        At = ai ? A : (similar(A')')
        Bt = bi ? B : (similar(B')')
        Ct = ci ? C : (similar(C')')
        spdw = LayoutPointers.DensePointerWrapper{(true, true)}(
          LayoutPointers.stridedpointer(At),
        )
        gsp, pres = @inferred(
          LayoutPointers.grouped_strided_pointer(
            (spdw, Bt, Ct),
            Val{(((1, 1), (3, 1)), ((1, 2), (2, 1)), ((2, 2), (3, 2)))}(),
          )
        )
        if ai === ci
          @test sizeof(gsp.strides) == 2sizeof(Int)
        end
        # Test to confirm that redundant strides are not stored in the grouped strided pointer
        @test sizeof(gsp) == sizeof(Int) * (6 - (ai & ci) - ((!ai) & bi) - ((!bi) & (!ci)))
        @test sizeof(gsp.offsets) == 0
        pA, pB, pC = @inferred(LayoutPointers.stridedpointers(gsp))
        @test pA === stridedpointer(At)
        @test pB === stridedpointer(Bt)
        @test pC === stridedpointer(Ct)
        Btsw = SizedWrapper{K,N}(Bt)
        gsp2, pres2 = @inferred(
          LayoutPointers.grouped_strided_pointer(
            (At, Btsw, Ct),
            Val{(((1, 1), (3, 1)), ((1, 2), (2, 1)), ((2, 2), (3, 2)))}(),
          )
        )
        @test sizeof(gsp2) == sizeof(Int) * (5 - (ai & ci) - ((!ai) & bi) - ((!bi) & (!ci)))

        pA2, pB2, pC2 = @inferred(LayoutPointers.stridedpointers(gsp2))
        @test pointer(pA2) == pointer(At)
        @test pointer(pB2) == pointer(Bt)
        @test pointer(pC2) == pointer(Ct)
        @test strides(pA2) == strides(pA)
        @test strides(pB2) == strides(pB)
        @test strides(pC2) == strides(pC)
      end
    end

    data_in_large = Array{Float64}(undef, 4, 4, 4, 4, 1)
    data_in = view(data_in_large, :, 1, :, :, 1)
    tmp1 = Array{Float64}(undef, 4, 4, 4)
    sp_data_in, sp_tmp1 = LayoutPointers.stridedpointers(
      LayoutPointers.grouped_strided_pointer((data_in, tmp1), Val((((1, 1), (2, 1)),)))[1],
    )
    @test sp_data_in === stridedpointer(data_in)
    @test sp_tmp1 === stridedpointer(tmp1)
  end

end

@inline function mulsizeof(::Type{T}, x::Number) where {T}
  (Base.allocatedinline(T) ? sizeof(T) : sizeof(Int)) * x
end
@generated function mulsizeof(::Type{T}, ::StaticInt{N}) where {T,N}
  st = Base.allocatedinline(T) ? sizeof(T) : sizeof(Int)
  Expr(:block, Expr(:meta, :inline), Expr(:call, Expr(:curly, :StaticInt, N * st)))
end
@inline mulsizeof(::Type{T}, ::Tuple{}) where {T} = ()
@inline mulsizeof(::Type{T}, x::Tuple{X}) where {T,X} =
  (mulsizeof(T, getfield(x, 1, false)),)
@inline mulsizeof(::Type{T}, x::Tuple{X1,X2,Vararg}) where {T,X1,X2} =
  (mulsizeof(T, getfield(x, 1, false)), mulsizeof(T, Base.tail(x))...)

@inline bytestrides(A::AbstractArray{T}) where {T} =
  mulsizeof(T, StaticArrayInterface.static_strides(A))

@inline memory_reference(A::NTuple) = memory_reference(StaticArrayInterface.device(A), A)
@inline memory_reference(A::AbstractArray) =
  memory_reference(StaticArrayInterface.device(A), A)
@inline memory_reference(A::BitArray) =
  Base.unsafe_convert(Ptr{Bit}, pointer(A.chunks)), A.chunks
@inline memory_reference(::CPUPointer, A) = pointer(A), preserve_buffer(A)
@inline memory_reference(
  ::CPUPointer,
  A::Union{
    LinearAlgebra.Adjoint,
    Base.ReshapedArray,
    Base.PermutedDimsArray,
    LinearAlgebra.Transpose,
  },
) = memory_reference(CPUPointer(), parent(A))
@inline function memory_reference(::CPUPointer, A::Base.ReinterpretArray{T}) where {T}
  p, m = memory_reference(CPUPointer(), parent(A))
  reinterpret(Ptr{T}, p), m
end
@inline ind_diff(::Base.Slice, ::Any) = Zero()
@inline ind_diff(x::AbstractRange, o) = static_first(x) - o
@inline ind_diff(x::IntegerTypes, o) = x - o
@inline memory_reference(::CPUPointer, A::SubArray) =
  memory_reference_subarray(CPUPointer(), A)
@inline memory_reference(::CPUTuple, A::SubArray) = memory_reference_subarray(CPUTuple(), A)
@inline function memory_reference_subarray(::PT, A::SubArray) where {PT}
  p, m = memory_reference(PT(), parent(A))
  pA = parent(A)
  offset = StaticArrayInterface.reduce_tup(
    +,
    _map(*, _map(ind_diff, A.indices, offsets(pA)), static_strides(pA)),
  )
  if offset isa Zero
    p, m
  else
    p + sizeof(eltype(A)) * offset, m
  end
end
@inline function memory_reference(::CPUTuple, A)
  r = Ref(A)
  Base.unsafe_convert(Ptr{eltype(A)}, r), r
end
@inline function memory_reference(::StaticArrayInterface.CheckParent, A)
  P = parent(A)
  if P === A
    memory_reference(StaticArrayInterface.CPUIndex(), A)
  else
    memory_reference(StaticArrayInterface.device(P), P)
  end
end
@inline memory_reference(::StaticArrayInterface.CPUIndex, A) =
  throw("Memory access for $(typeof(A)) not implemented yet.")

@inline StaticArrayInterface.contiguous_axis(
  ::Type{A},
) where {T,N,C,A<:AbstractStridedPointer{T,N,C}} = StaticInt{C}()
@inline StaticArrayInterface.contiguous_batch_size(
  ::Type{A},
) where {T,N,C,B,A<:AbstractStridedPointer{T,N,C,B}} = StaticInt{B}()
@inline StaticArrayInterface.stride_rank(
  ::Type{A},
) where {T,N,C,B,R,A<:AbstractStridedPointer{T,N,C,B,R}} = _map(StaticInt, R)
@inline memory_reference(A::AbstractStridedPointer) = pointer(A), nothing

@inline Base.eltype(::AbstractStridedPointer{T}) where {T} = T

struct StridedPointer{T,N,C,B,R,X,O} <: AbstractStridedPointer{T,N,C,B,R,X,O}
  p::Ptr{T}
  si::StrideIndex{N,R,C,X,O}
end
@inline stridedpointer(
  p::Ptr{T},
  si::StrideIndex{N,R,C,X,O},
  ::StaticInt{B},
) where {T,N,R,C,B,X,O} = StridedPointer{T,N,C,B,R,X,O}(p, si)
@inline stridedpointer(p::Ptr{T}, si::StrideIndex{N,R,C,X,O}) where {T,N,R,C,X,O} =
  StridedPointer{T,N,C,0,R,X,O}(p, si)

@inline bytestrideindex(A::AbstractArray{T}) where {T} = mulstrides(T, StrideIndex(A))

@inline function mulstrides(::Type{T}, si::StrideIndex{N,R,C,X,O}) where {N,R,C,X,O,T}
  StrideIndex{N,R,C}(mulsizeof(T, si.strides), si.offsets)
end
@inline function stridedpointer(A::AbstractArray)
  p, r = memory_reference(A)
  stridedpointer(p, bytestrideindex(A), StaticArrayInterface.contiguous_batch_size(A))
end
@inline function stridedpointer_preserve(A::AbstractArray)
  p, r = memory_reference(A)
  stridedpointer(p, bytestrideindex(A), StaticArrayInterface.contiguous_batch_size(A)), r
end
@inline function stridedpointer_preserve(t::NTuple)
  p, r = memory_reference(t)
  stridedpointer(
    p,
    StaticArrayInterface.StrideIndex{1,(1,),1}((static(sizeof(eltype(t))),), (static(1),)),
    static(0),
  ),
  r
end
@inline val_stride_rank(::AbstractStridedPointer{T,N,C,B,R}) where {T,N,C,B,R} = Val{R}()
@generated val_dense_dims(::AbstractStridedPointer{T,N}) where {T,N} =
  Val{ntuple(==(0), Val(N))}()
@inline val_stride_rank(A) = Val(known(stride_rank(A)))
@inline val_dense_dims(A) = Val(known(StaticArrayInterface.dense_dims(A)))

function zerotupleexpr(N::Int)
  t = Expr(:tuple)
  for n = 1:N
    push!(t.args, :(Zero()))
  end
  Expr(:block, Expr(:meta, :inline), t)
end
@generated zerotuple(::Val{N}) where {N} = zerotupleexpr(N)
# @inline center(p::AbstractStridedPointer{T,N}) where {T,N} = gesp(p, zerotuple(Val(N)))
@inline zero_offsets(si::StrideIndex{N,R,C}) where {N,R,C} =
  StrideIndex{N,R,C}(getfield(si, :strides), zerotuple(Val(N)))
@inline zero_offsets(sptr::AbstractStridedPointer) = stridedpointer(
  pointer(sptr),
  zero_offsets(StrideIndex(sptr)),
  contiguous_batch_size(sptr),
)
@inline zstridedpointer(A) = zero_offsets(stridedpointer(A))
@inline function zstridedpointer_preserve(A::AbstractArray{T,N}) where {T,N}
  strd = mulsizeof(T, StaticArrayInterface.static_strides(A))
  si = StrideIndex{N,known(stride_rank(A)),Int(contiguous_axis(A))}(
    strd,
    zerotuple(Val(N)),
    Zero(),
  )
  p, r = memory_reference(A)
  stridedpointer(p, si, contiguous_batch_size(A)), r
end

@inline Base.similar(sptr::StridedPointer, ptr::Ptr) =
  stridedpointer(ptr, StrideIndex(sptr), contiguous_batch_size(sptr))

Base.unsafe_convert(::Type{Ptr{T}}, ptr::AbstractStridedPointer{T}) where {T} = pointer(ptr)
# Shouldn't need to special case Array
@generated function nopromote_axis_indicator(::AbstractStridedPointer{<:Any,N}) where {N}
  t = Expr(:tuple)
  foreach(n -> push!(t.args, True()), 1:N)
  Expr(:block, Expr(:meta, :inline), t)
end

@inline dynamic_offsets(si::StrideIndex{N,R,C}) where {N,R,C} =
  StrideIndex{N,R,C}(static_strides(si), _map(Int, offsets(si)))
struct StridedBitPointer{N,C,B,R,X,O} <: AbstractStridedPointer{Bit,N,C,B,R,X,O}
  p::Ptr{Bit}
  si::StrideIndex{N,R,C,X,O}
end
@inline stridedpointer(
  p::Ptr{Bit},
  si::StrideIndex{N,R,C,X,O},
  ::StaticInt{B},
) where {N,R,C,B,X,O} = StridedBitPointer{N,C,B,R,X,NTuple{N,Int}}(p, dynamic_offsets(si))
@inline stridedpointer(p::Ptr{Bit}, si::StrideIndex{N,R,C,X,O}) where {N,R,C,X,O} =
  StridedBitPointer{N,C,0,R,X,NTuple{N,Int}}(p, dynamic_offsets(si))

@inline Base.pointer(p::Union{StridedPointer,StridedBitPointer}) = getfield(p, :p)
@inline StaticArrayInterface.StrideIndex(sptr::Union{StridedPointer,StridedBitPointer}) =
  getfield(sptr, :si)
@inline bytestrideindex(sptr::AbstractStridedPointer) = StrideIndex(sptr)

@inline bytestrides(si::StrideIndex) =
  _map(Base.Fix2(*, StaticInt{8}()), getfield(si, :strides))
@inline bytestrides(ptr::AbstractStridedPointer) = getfield(StrideIndex(ptr), :strides)
@inline Base.strides(ptr::AbstractStridedPointer) = getfield(StrideIndex(ptr), :strides)
@inline StaticArrayInterface.static_strides(ptr::AbstractStridedPointer) =
  getfield(StrideIndex(ptr), :strides)
@inline StaticArrayInterface.offsets(ptr::AbstractStridedPointer) =
  offsets(StrideIndex(ptr))
@inline StaticArrayInterface.contiguous_axis_indicator(
  ptr::AbstractStridedPointer{T,N,C},
) where {T,N,C} = contiguous_axis_indicator(StaticInt{C}(), Val{N}())


@inline function similar_with_offset(
  sptr::AbstractStridedPointer{T,N,C,B,R},
  ptr::Ptr,
  offset::Tuple,
) where {T,N,C,B,R}
  si = StrideIndex{N,R,C}(static_strides(sptr), offset)
  stridedpointer(ptr, si, contiguous_batch_size(sptr))
end
@inline function similar_no_offset(
  sptr::AbstractStridedPointer{T,N,C,B,R},
  ptr::Ptr,
) where {T,N,C,B,R}
  si = StrideIndex{N,R,C}(static_strides(sptr), zerotuple(Val(N)))
  stridedpointer(ptr, si, contiguous_batch_size(sptr))
end

# There is probably a smarter way to do indexing adjustment here.
# The reasoning for the current approach of geping for Zero() on extracted inds
# and for offsets otherwise is best demonstrated witht his motivational example:
#
# A = OffsetArray(rand(10,11), 6:15, 5:15);
# for i in 6:15
# s += A[i,i]
# end
# first access is at zero-based index
# (first(6:16) - StaticArrayInterface.offsets(a)[1]) * StaticArrayInterface.static_strides(A)[1] + (first(6:16) - StaticArrayInterface.offsets(a)[2]) * StaticArrayInterface.static_strides(A)[2]
# equal to
#  (6 - 6)*1 + (6 - 5)*10 = 10
# i.e., the 1-based index 11.
# So now we want to adjust the offsets and pointer's value
# so that indexing it with a single `i` (after summing strides) is correct.
# Moving to 0-based indexing is easiest for combining strides. So we gep by 0 on these inds.
# E.g., gep(stridedpointer(A), (0,0))
# ptr += (0 - 6)*1 + (0 - 5)*10 = -56
# new stride = 1 + 10 = 11
# new_offset = 0
# now if we access the 6th element
# (6 - new_offse) * new_stride
# ptr += (6 - 0) * 11 = 66
# cumulative:
# ptr = pointer(A) + 66 - 56  = pointer(A) + 10
# so initial load is of pointer(A) + 10 -> the 11th element w/ 1-based indexing

@inline stridedpointer(ptr::AbstractStridedPointer) = ptr
@inline stridedpointer_preserve(ptr::AbstractStridedPointer) = (ptr, nothing)

struct FastRange{T,F,S,O}# <: AbstractStridedPointer{T,1,1,0,(1,),Tuple{S},Tuple{O}}# <: AbstractRange{T}
  f::F
  s::S
  o::O
end
FastRange{T}(f::F, s::S) where {T<:IntegerTypes,F,S} = FastRange{T,Zero,S,F}(Zero(), s, f)
FastRange{T}(f::F, s::S, o::O) where {T,F,S,O} = FastRange{T,F,S,O}(f, s, o)

FastRange{T}(f::F, s::S) where {T<:FloatingTypes,F,S} = FastRange{T,F,S,Int}(f, s, 0)
# FastRange{T}(f,s) where {T<:FloatingTypes} = FastRange{T}(f,s,fast_int64_to_double())
# FastRange{T}(f::F,s::S,::True) where {T<:FloatingTypes,F,S} = FastRange{T,F,S,Int}(f,s,0)
# FastRange{T}(f::F,s::S,::False) where {T<:FloatingTypes,F,S} = FastRange{T,F,S,Int32}(f,s,zero(Int32))

@inline function memory_reference(r::AbstractRange{T}) where {T}
  s = StaticArrayInterface.static_step(r)
  FastRange{T}(StaticArrayInterface.static_first(r) - s, s), nothing
end
@inline memory_reference(r::FastRange) = (r, nothing)
@inline bytestrides(::FastRange{T}) where {T} = (StaticInt(sizeof(T)),)
@inline StaticArrayInterface.offsets(::FastRange) = (One(),)
@inline val_stride_rank(::FastRange) = Val{(1,)}()
@inline val_dense_dims(::FastRange) = Val{(true,)}()
@inline StaticArrayInterface.contiguous_axis(::FastRange) = One()
@inline StaticArrayInterface.contiguous_batch_size(::FastRange) = Zero()

@inline stridedpointer(fr::FastRange, ::StrideIndex, ::StaticInt{0}) = fr
struct NoStrides end
@inline bytestrideindex(::FastRange) = NoStrides()
@inline StaticArrayInterface.offsets(::NoStrides) = NoStrides()
@inline reconstruct_ptr(r::FastRange{T}, o) where {T} =
  FastRange{T}(getfield(r, :f), getfield(r, :s), o)


@inline function zero_offsets(fr::FastRange{T,Zero}) where {T<:IntegerTypes}
  s = getfield(fr, :s)
  FastRange{T}(Zero(), s, getfield(fr, :o) + s)
end
@inline function zero_offsets(fr::FastRange{T}) where {T<:FloatingTypes}
  FastRange{T}(getfield(fr, :f), getfield(fr, :s), getfield(fr, :o) + 1)
end

# `FastRange{<:FloatingTypes}` must use an integer offset because `ptrforcomparison` needs to be exact/integral.

# discard unnueeded align/reg size info
@inline Base.eltype(::FastRange{T}) where {T} = T

# @inline Base.pointer(p::AbstractStridedPointer, i::Tuple) = pointer(p) + StrideIndex(p)[i...]
function reinterpret_strideindex_quote(
  sz_new::Int,
  sz_old::Int,
  C::Int,
  N::Int,
  curly::Expr,
)
  if sz_old == sz_new
    # size_expr = :size_A
    bx_expr = :bx
  else
    @assert 1 ≤ C ≤ N
    # size_expr = Expr(:tuple)
    bx_expr = Expr(:tuple)
    for n ∈ 1:N
      # sz_n = Expr(:call, GlobalRef(Core,:getfield), :size_A, n, false)
      bx_n = Expr(:call, GlobalRef(Core, :getfield), :bx, n, false)
      if n ≠ C
        # push!(size_expr.args, sz_n)
        push!(bx_expr.args, bx_n)
      elseif sz_old > sz_new
        si = :(StaticInt{$(sz_old ÷ sz_new)}())
        # push!(size_expr.args, Expr(:call, :*, sz_n, si))
        push!(bx_expr.args, Expr(:call, :÷, bx_n, si))
      else
        si = :(StaticInt{$(sz_new ÷ sz_old)}())
        # push!(size_expr.args, Expr(:call, :÷, sz_n, si))
        push!(bx_expr.args, Expr(:call, :*, bx_n, si))
      end
    end
  end
  quote
    $(Expr(:meta, :inline))
    bx = si.strides
    $curly($bx_expr, si.offsets)
  end
end
@generated function reinterpret_strideindex(
  ::Type{Tnew},
  ::Type{Told},
  si::StrideIndex{N,R,C},
) where {Tnew,Told,N,R,C}
  # 1+2
  reinterpret_strideindex_quote(
    offsetsize(Tnew),
    offsetsize(Told),
    C,
    N,
    :(StrideIndex{$N,$R,$C}),
  )
end
@generated function Base.reinterpret(
  ::Type{Tnew},
  sp::AbstractStridedPointer{Told,N,C,B,R},
) where {Tnew,Told,N,C,B,R}
  # 1+2
  sz_old = offsetsize(Told)
  sz_new = offsetsize(Tnew)
  Bnew = ((B > 0) & (sz_new ≠ sz_old)) ? ((B * sz_old) ÷ sz_new) : B
  quote
    $(Expr(:meta, :inline))
    si = reinterpret_strideindex(Tnew, Told, StrideIndex(sp))
    stridedpointer(reinterpret(Ptr{$Tnew}, pointer(sp)), si, StaticInt{$Bnew}())
  end
end

@inline vload(::StaticInt{N}, args...) where {N} = StaticInt{N}()
@inline stridedpointer(::StaticInt{N}) where {N} = StaticInt{N}()
@inline zero_offsets(::StaticInt{N}) where {N} = StaticInt{N}()

```@meta
CurrentModule = LayoutPointers
```

# LayoutPointers

Documentation for [LayoutPointers](https://github.com/JuliaSIMD/LayoutPointers.jl).

```@index
```

```@autodocs
Modules = [LayoutPointers]
```
